/*
 * FILE:    transmit.h
 * PROGRAM: RAT
 * AUTHOR:  Isidor Kouvelas / Orion Hodson
 *
 * $Revision: 1.7 $
 * $Date: 1998/09/12 14:40:37 $
 *
 * Copyright (c) 1995,1996 University College London
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, is permitted, for non-commercial use only, provided
 * that the following conditions are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by the Computer Science
 *      Department at University College London
 * 4. Neither the name of the University nor of the Department may be used
 *    to endorse or promote products derived from this software without
 *    specific prior written permission.
 * Use of this software for commercial purposes is explicitly forbidden
 * unless prior written permission is obtained from the authors.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#ifndef _transmit_h_
#define _transmit_h_

#include "session.h"
#include "codec.h"

struct s_tx_buffer;
struct session_tag;
struct s_speaker_table;
struct s_minibuf;

struct s_tx_buffer   *tx_create(struct session_tag *sp, u_int16 unit_size, u_int16 channels);
void                  tx_destroy       (struct session_tag *sp);
int                   tx_read_audio    (struct session_tag *sp);
int                   tx_process_audio (struct session_tag *sp);
void                  tx_start (struct session_tag *sp);
void                  tx_stop  (struct session_tag *sp);
void                  tx_send  (struct session_tag *sp);
void                  tx_update_ui    (struct session_tag *sp);
void                  tx_igain_update (struct session_tag *sp);

#endif /* _transmit_h_ */
